# Pitaya

Lanceur d'application pour GNU/Linux

## Démarrer avec les sources

### Dépendences de développement

- [NodeJS](https://nodejs.org/) - Dernière version stable, testé sur la 0.12.*
- [NPM](https://www.npmjs.com/) - Normalement automatiquement installé avec NodeJS.

### Initialisation du projet

```
git clone https://forge.cadoles.com/wpetit/pitaya.git
cd pitaya
git checkout develop
npm install
DEBUG=pitaya* npm start
```

## Options

```
--profile=<chemin_profile>    Chemin vers le fichier de profil à charger dans l'application.
--edit                        Ouvrir l'application en mode édition.
```

### Passer des options en développement

```
npm start -- [options...]
```

Exemple:
```
npm start -- --profile=my-profile.json
```

## Comment construire l'application depuis les sources

```
npm run build
```

Un dossier `pitaya-<version>-<target>-<arch>` sera créé dans le répertoire `./build`. Celui ci contient tous les fichiers nécessaires à l'application.


## Comment contribuer

Ce projet utilise la méthodologie [Git Flow](http://nvie.com/posts/a-successful-git-branching-model/).

## Licence

GPLv3
