var redux = require('redux');
var thunkMiddleware = require('redux-thunk');
var loggerMiddleware = require('redux-logger');
var reducers = require('./reducers');
var loggerMiddleware = require('./middlewares/logger');

var createStore = redux.applyMiddleware(
  thunkMiddleware,
  loggerMiddleware
)(redux.createStore);

var appReducer = redux.combineReducers({
  profile: reducers.profile,
  processOpts: reducers.processOpts,
  desktopApps: reducers.desktopApps,
  theme: reducers.theme
});

module.exports = createStore(appReducer);
