var debug = require('debug');
var util = require('util');

module.exports = function createLogger(namespace) {
  var logger = debug('pitaya:'+namespace);
  var isNWContext = 'window' in global;
  var console = isNWContext ? global.window.console : global.console;
  logger.log = function() {
    if(isNWContext) {
      console.log.apply(console, arguments);
    } else {
      var str = util.format.apply(util, arguments);
      console.log(str);
    }
  };
  return logger;
};
